package test.auth.app.jboss;

import java.security.acl.Group;
import java.util.Map;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.login.LoginException;

import org.jboss.security.SimpleGroup;
import org.jboss.security.SimplePrincipal;
import org.jboss.security.auth.spi.UsernamePasswordLoginModule;

public class JbossCustomLoginModule extends UsernamePasswordLoginModule {

  @Override
  @SuppressWarnings({"rawtypes", "unchecked"})
  public void initialize(Subject subject, CallbackHandler callbackHandler, Map sharedState,
      Map options) {

    super.initialize(subject, callbackHandler, sharedState, options);
  }

  @Override
  protected boolean validatePassword(String inputPassword, String expectedPassword) {
    return true;// ("admin".equalsIgnoreCase(super.getUsername()));
  }

  @Override
  protected Group[] getRoleSets() throws LoginException {

    System.out.println("getting roles from custom login module");

    SimpleGroup group = new SimpleGroup("Roles");

    try {
      group.addMember(new SimplePrincipal(getMainRole()));
    } catch (Exception e) {
      throw new LoginException("Failed to create group member for " + group);
    }

    return new Group[] {group};
  }

  // Derives password for expectedPassword argument of validatePassword(). Not used here.
  @Override
  protected String getUsersPassword() throws LoginException {
    return "";
  }

  private String getMainRole() {
    return "User";
  }
}
